<?php
$login_field_name="{$this->plugin_name}-4dealer_login";
$token_field_name="{$this->plugin_name}-4dealer_token";
$hide_checkbox_name="{$this->plugin_name}-4dealer_hide_duplicates";
$hide_rule_select="{$this->plugin_name}-4dealer_hide_duplicates_rule";
$hide_empty_pic_checkbox_name="{$this->plugin_name}-4dealer_hide_goods_without_pics";
$short_field_name="{$this->plugin_name}-4dealer_short_step";
$full_field_name="{$this->plugin_name}-4dealer_full_step";
$exclude_str="{$this->plugin_name}-4dealer_exclude_str";
$calls_per_iteration="{$this->plugin_name}-4dealer_calls_per_iteration";
$logger="{$this->plugin_name}-4dealer_logger";
$pid_method="{$this->plugin_name}-4dealer_pid_method";

$calls_per_iteration_val = get_option($calls_per_iteration, 1);
$calls_per_iteration_val = $calls_per_iteration_val ? $calls_per_iteration_val : 1;
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://4dealer.ru/
 * @since      1.0.0
 *
 * @package    Wp_Fdeal
 * @subpackage Wp_Fdeal/admin/partials
 */
?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<div class="wrap">

    <h2>Общие настройки</h2>

    <form method="post" name="cleanup_options" action="options.php">
        <?php settings_fields( $this->plugin_name.'-settings-group' ); ?>
        <fieldset>
            <p>Логин доступа</p>
            <legend class="screen-reader-text"><span><?php _e('Ввведите логин доступа к API 4dealer', $this->plugin_name); ?></span></legend>
            <input type="text" class="regular-text" id="<?php echo $login_field_name?>" name="<?php echo $login_field_name?>" value="<?php echo esc_attr( get_option($login_field_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Ключ доступа</p>
            <legend class="screen-reader-text"><span><?php _e('Ввведите ключ доступа к API 4dealer', $this->plugin_name); ?></span></legend>
            <input type="text" class="regular-text" id="<?php echo $token_field_name?>" name="<?php echo $token_field_name?>" value="<?php echo esc_attr( get_option($token_field_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Скрывать "дубликаты" товаров от разных поставщиков</p>
            <legend class="screen-reader-text"><span></span></legend>
            <?php $checked=get_option($hide_checkbox_name,true)?' checked="checked" ':''; ?>
            <input value="true" type="checkbox" <?php echo $checked; ?> class="regular-text" id="<?php echo $hide_checkbox_name?>" name="<?php echo $hide_checkbox_name?>" value="<?php echo esc_attr( get_option($hide_checkbox_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Скрывать товары без картинок</p>
            <legend class="screen-reader-text"><span></span></legend>
            <?php $checked=get_option($hide_empty_pic_checkbox_name,true)?' checked="checked" ':''; ?>
            <input value="true" type="checkbox" <?php echo $checked; ?> class="regular-text" id="<?php echo $hide_empty_pic_checkbox_name?>" name="<?php echo $hide_empty_pic_checkbox_name?>" value="<?php echo esc_attr( get_option($hide_empty_pic_checkbox_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Ценовой критерий скрытия дубликатов</p>
            <legend class="screen-reader-text"><span></span></legend>
            <select name="<?php echo $hide_rule_select?>" id="<?php echo $hide_rule_select?>">
                <option value="1" <?php selected(get_option($hide_rule_select), 1); ?>>Больше</option>
                <option value="2" <?php selected(get_option($hide_rule_select), 2); ?>>Меньше</option>
            </select>
        </fieldset>

        <fieldset>
            <p>Фильтр названий</p>
            <legend class="screen-reader-text"><span></span></legend>
            <textarea name="<?php echo $exclude_str?>" id="<?php echo $exclude_str?>"><?php echo esc_attr( get_option($exclude_str) ); ?></textarea>
        </fieldset>

	    <fieldset>
		    <p>Количество вызовов выполняемых за итерацию</p>
		    <small>
			    Количество вызовов процесса за один шаг (от 1 до 7, по умолчанию 1) - при увеличении этого числа будет запущено большее процессов
			    создания/обновления карточек товара за один запуск шага обновления. Увеличение количества вызовов может ускорить процесс обновления,
                            и снизить требуемое количество оперативной памяти. <br>
                            Мы рекомендуем постепенно увеличивать количество запускаемых процессов, соразмерно уменьшая количество товаров за процесс.

		    </small>
		    <br><br>
		    <legend class="screen-reader-text"><span></span></legend>
		    <input type="text" class="regular-text" id="<?php echo $calls_per_iteration?>" name="<?php echo $calls_per_iteration ?>"
		           value="<?php echo esc_attr($calls_per_iteration_val); ?>"/>

	    </fieldset>

	    <fieldset>
		    <p>Количество товаров за процесс быстрого обновления</p>
		    <legend class="screen-reader-text"><span></span></legend>
		    <input type="text" class="regular-text" data-id="short-update-quantity" id="<?php echo $short_field_name ?>"
		           name="<?php echo $short_field_name ?>"
		           value="<?php echo esc_attr(get_option($short_field_name, 500)); ?>"/>
	    </fieldset>

	    <fieldset>
		    <p>Количество товаров за процесс полного обновления</p>
		    <legend class="screen-reader-text"><span></span></legend>
		    <input type="text" class="regular-text" data-id="full-update-quantity" id="<?php echo $full_field_name ?>"
		           name="<?php echo $full_field_name ?>"
		           value="<?php echo esc_attr(get_option($full_field_name, 100)); ?>"/>
	    </fieldset>

	    <fieldset>
            <p>Записывать логи операций</p>
            <legend class="screen-reader-text"><span></span></legend>
            <?php $checked=get_option($logger,false)?' checked="checked" ':''; ?>
            <input value="true" type="checkbox" <?php echo $checked; ?> class="regular-text" id="<?php echo $logger?>" name="<?php echo $logger?>" value="<?php echo esc_attr( get_option($logger) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Метод отслеживания запуска процессов</p>
            <legend class="screen-reader-text"><span></span></legend>
            <select name="<?php echo $pid_method?>" id="<?php echo $pid_method?>">
                <option value="1" <?php selected(get_option($pid_method), 1); ?>>Процессами PHP (рекомендуется)</option>
                <option value="2" <?php selected(get_option($pid_method), 2); ?>>Файлами (для PHP как CGI)</option>
            </select>
        </fieldset>


        <?php submit_button('Сохранить изменения', 'primary','submit', TRUE); ?>

    </form>

</div>

