<?php
$login_field_name="{$this->plugin_name}-4dealer_login";
$token_field_name="{$this->plugin_name}-4dealer_token";
$hide_checkbox_name="{$this->plugin_name}-4dealer_hide_duplicates";
$hide_rule_select="{$this->plugin_name}-4dealer_hide_duplicates_rule";
$hide_empty_pic_checkbox_name="{$this->plugin_name}-4dealer_hide_goods_without_pics";
/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       http://4dealer.ru/
 * @since      1.0.0
 *
 * @package    Wp_Fdeal
 * @subpackage Wp_Fdeal/admin/partials
 */
?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<div class="wrap">

    <h2>Общие настройки</h2>

    <form method="post" name="cleanup_options" action="options.php">
        <?php settings_fields( $this->plugin_name.'-settings-group' ); ?>
        <fieldset>
            <p>Логин доступа</p>
            <legend class="screen-reader-text"><span><?php _e('Ввведите логин доступа к API 4dealer', $this->plugin_name); ?></span></legend>
            <input type="text" class="regular-text" id="<?php echo $login_field_name?>" name="<?php echo $login_field_name?>" value="<?php echo esc_attr( get_option($login_field_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Ключ доступа</p>
            <legend class="screen-reader-text"><span><?php _e('Ввведите ключ доступа к API 4dealer', $this->plugin_name); ?></span></legend>
            <input type="text" class="regular-text" id="<?php echo $token_field_name?>" name="<?php echo $token_field_name?>" value="<?php echo esc_attr( get_option($token_field_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Скрывать "дубликаты" товаров от разных поставщиков</p>
            <legend class="screen-reader-text"><span></span></legend>
            <?php $checked=get_option($hide_checkbox_name,true)?' checked="checked" ':''; ?>
            <input value="true" type="checkbox" <?php echo $checked; ?> class="regular-text" id="<?php echo $hide_checkbox_name?>" name="<?php echo $hide_checkbox_name?>" value="<?php echo esc_attr( get_option($hide_checkbox_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Скрывать товары без картинок</p>
            <legend class="screen-reader-text"><span></span></legend>
            <?php $checked=get_option($hide_empty_pic_checkbox_name,true)?' checked="checked" ':''; ?>
            <input value="true" type="checkbox" <?php echo $checked; ?> class="regular-text" id="<?php echo $hide_empty_pic_checkbox_name?>" name="<?php echo $hide_empty_pic_checkbox_name?>" value="<?php echo esc_attr( get_option($hide_empty_pic_checkbox_name) ); ?>"/>
        </fieldset>

        <fieldset>
            <p>Ценовой критерий скрытия дубликатов</p>
            <legend class="screen-reader-text"><span></span></legend>
            <select name="<?php echo $hide_rule_select?>" id="<?php echo $hide_rule_select?>">
                <option value="1" <?php selected(get_option($hide_rule_select), 1); ?>>Больше</option>
                <option value="2" <?php selected(get_option($hide_rule_select), 2); ?>>Меньше</option>
            </select>

        </fieldset>


        <?php submit_button('Сохранить изменения', 'primary','submit', TRUE); ?>

    </form>

</div>

